﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;
using Infragistics.Windows.DataPresenter;

namespace XamDataGridCustomCommands
{
    public class MyKeyboardCommand : ICommand
    {
        public bool CanExecute(object parameter)
        {
            return true;
        }
        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            this.IterateRecords((parameter as XamDataGrid).Records);
        }

        public void IterateRecords(RecordCollectionBase records)
        {
            //レコード コレクションで繰り返し
            //https://jp.infragistics.com/help/wpf/xamdatapresenter-iterate-through-the-records-collection

            foreach (Record rec in records)
            {
                if (rec.RecordType == RecordType.GroupByField || rec.RecordType == RecordType.GroupByFieldLayout)
                {
                    GroupByRecord groupRecord = (GroupByRecord)rec;

                    if (groupRecord.HasChildren)
                        IterateRecords(groupRecord.ChildRecords);
                }
                else if (rec.RecordType == RecordType.DataRecord)
                {
                    DataRecord dataRecord = (DataRecord)rec;

                    dataRecord.IsSelected = true;

                    if (dataRecord.HasChildren)
                        IterateRecords(dataRecord.ChildRecords);

                }
                else if (rec.RecordType == RecordType.ExpandableFieldRecord)
                {
                    ExpandableFieldRecord expandableRecord = (ExpandableFieldRecord)rec;

                    expandableRecord.IsSelected = true;

                    if (expandableRecord.HasChildren)
                        IterateRecords(expandableRecord.ChildRecords);

                }
            }
        }

    }
}
